# StrideArraysCore

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaSIMD.github.io/StrideArraysCore.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaSIMD.github.io/StrideArraysCore.jl/dev)
[![Build Status](https://github.com/JuliaSIMD/StrideArraysCore.jl/workflows/CI/badge.svg)](https://github.com/JuliaSIMD/StrideArraysCore.jl/actions)
[![Coverage](https://codecov.io/gh/JuliaSIMD/StrideArraysCore.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaSIMD/StrideArraysCore.jl)

Defines the core `PtrArray` type so that some libraries can make use of it internally without the need for circular dependencies.
[StrideArrays](https://github.com/chriselrod/StrideArrays.jl) extends this type with many methods and functionality. It is
recommended you depend on and use `StrideArrays` instead.


Example initialization:
```julia
julia> using StrideArraysCore

julia> A = StrideArray(undef, 2, 5) # `Float64` is default eltype
2×5 StrideArray{Tuple{Int64, Int64}, (true, true), Float64, 2, 1, 0, (1, 2), Tuple{StaticInt{8}, Int64}, Tuple{StaticInt{1}, StaticInt{1}}, Vector{Float64}}:
 1.5e-323  -2.0092e-237  4.94e-321   1.0e-322  1.6e-322
 1.6e-322   4.94e-322    1.235e-321  1.5e-323  2.0e-323

julia> B = StrideArray{Float32}(zero, 2, 5) # can specify initialization function; function must have 1-arg method accepting eltype as argument
2×5 StrideArray{Tuple{Int64, Int64}, (true, true), Float32, 2, 1, 0, (1, 2), Tuple{StaticInt{4}, Int64}, Tuple{StaticInt{1}, StaticInt{1}}, Matrix{Float32}}:
 0.0  0.0  0.0  0.0  0.0
 0.0  0.0  0.0  0.0  0.0

julia> C = StrideArray{Float32}(one, static(2), 5) # sizes may optionally be static
2×5 StrideArray{Tuple{StaticInt{2}, Int64}, (true, true), Float32, 2, 1, 0, (1, 2), Tuple{StaticInt{4}, StaticInt{8}}, Tuple{StaticInt{1}, StaticInt{1}}, Vector{Float32}} with indices 1:1:2×Base.OneTo(5):
 1.0  1.0  1.0  1.0  1.0
 1.0  1.0  1.0  1.0  1.0

julia> D = StrideArray{Float32}(one, static(2), static(5)) # all sizes being static will allow the compiler to elide the allocation if the array does not escape.
2×5 StrideArraysCore.StaticStrideArray{Tuple{StaticInt{2}, StaticInt{5}}, (true, true), Float32, 2, 1, 0, (1, 2), Tuple{StaticInt{4}, StaticInt{8}}, Tuple{StaticInt{1}, StaticInt{1}}, 10} with indices 1:1:2×1:1:5:
 1.0  1.0  1.0  1.0  1.0
 1.0  1.0  1.0  1.0  1.0

julia> using StrideArraysCore, BenchmarkTools

julia> @inline function alloctest()
           D = StrideArray(one, static(2), static(5))
           s = 0.0
           for i in eachindex(D)
               s += D[i]
           end
           s
       end
alloctest (generic function with 1 method)

julia> @btime alloctest()
  1.214 ns (0 allocations: 0 bytes)
10.0

julia> @code_llvm debuginfo=:none alloctest() # compiler compiled-away function
define double @julia_alloctest_1199() #0 {
L67.9:
  ret double 1.000000e+01
}
```

using Base: @propagate_inbounds

@generated function permtuple(x::Tuple, ::Val{R}) where {R}
  t = Expr(:tuple)
  for r in R
    push!(t.args, Expr(:call, getfield, :x, r))
  end
  Expr(:block, Expr(:meta, :inline), t)
end
@generated function invpermtuple(x::Tuple, ::Val{R}) where {R}
  t = Expr(:tuple)
  for i in eachindex(R)
    j = findfirst(==(i), R)::Int
    push!(t.args, Expr(:call, getfield, :x, j))
  end
  Expr(:block, Expr(:meta, :inline), t)
end

@inline _strides(::Tuple{}, ::Tuple{}) = ()
@inline _strides(::Tuple{}, ::Tuple{}, prev::Integer) = ()

struct StrideReset{T}
  x::T
end
@inline Base.:(*)(x::StrideReset, y::Union{Integer,StaticInt}) = x.x * y
@inline __scale(x::StrideReset, y::Union{Integer,StaticInt}) =
  StrideReset(x.x * y)
@inline __scale(x::Union{Integer,StaticInt}, y::Union{Integer,StaticInt}) =
  x * y
# three arg calcs div((x * y), z)
@inline __scale(
  x::StrideReset,
  y::Union{Integer,StaticInt},
  z::Union{Integer,StaticInt}
) = StrideReset(div(x.x * y, z))
@inline __scale(
  x::Union{Integer,StaticInt},
  y::Union{Integer,StaticInt},
  z::Union{Integer,StaticInt}
) = div(x * y, z)
# sizes M x N
# strides nothing x nothing -> static(1) x M
# strides L x nothing -> L x L*M
# strides nothing x K -> static(1) x K
# strides L x K -> L x L*K
@inline function _strides(
  sizes::Tuple{Integer,Vararg{Integer,N}},
  strides::Tuple{Integer,Vararg{Any,N}},
  prev::Integer
) where {N}
  next = prev * first(strides)
  (next, _strides(Base.tail(sizes), Base.tail(strides), next)...)
end
@inline function _strides(
  sizes::Tuple{Integer,Vararg{Integer,N}},
  strides::Tuple{Nothing,Vararg{Any,N}},
  prev::Integer
) where {N}
  next = prev * first(sizes)
  (next, _strides(Base.tail(sizes), Base.tail(strides), next)...)
end
@inline function _strides(
  sizes::Tuple{Integer,Vararg{Integer,N}},
  strides::Tuple{StrideReset{T},Vararg{Any,N}},
  ::Integer
) where {N,T}
  next = getfield(first(strides), :x)
  (next, _strides(Base.tail(sizes), Base.tail(strides), next)...)
end

# entry point
@inline function _strides_nobit(
  sizes::Tuple{Integer,Vararg{Integer,N}},
  strides::Tuple{Integer,Vararg{Any,N}}
) where {N}
  prev = first(strides)
  (prev, _strides(Base.front(sizes), Base.tail(strides), prev)...)
end
@inline function _strides_nobit(
  sizes::Tuple{Integer,Vararg{Integer,N}},
  strides::Tuple{StrideReset{T},Vararg{Any,N}}
) where {N,T}
  next = getfield(first(strides), :x)
  (next, _strides(Base.front(sizes), Base.tail(strides), next)...)
end
@inline function _strides_nobit(
  sizes::Tuple{Integer,Vararg{Integer,N}},
  strides::Tuple{Nothing,Vararg{Any,N}}
) where {N}
  prev = static(1)
  (prev, _strides(Base.front(sizes), Base.tail(strides), prev)...)
end

# entry point, guaranteed to have N > 0
@inline function _strides_bit(
  sizes::Tuple{Integer,Vararg{Integer,N}},
  strides::Tuple{Integer,Vararg{Any,N}}
) where {N}
  prev = (first(strides) + static(7)) & static(-8)
  (prev, _strides(Base.front(sizes), Base.tail(strides), prev)...)
end
@inline function _strides_bit(
  sizes::Tuple{Integer,Vararg{Integer,N}},
  strides::Tuple{StrideReset{T},Vararg{Any,N}}
) where {N,T}
  next = (getfield(first(strides), :x) + static(7)) & static(-8)
  (next, _strides(Base.front(sizes), Base.tail(strides), next)...)
end
@inline function __strides_bit(
  sizes::Tuple{Integer,Vararg{Integer,N}},
  strides::Tuple{Integer,Vararg{Any,N}}
) where {N}
  next = (first(strides) + static(7)) & static(-8)
  (next, _strides(Base.tail(sizes), Base.tail(strides), next)...)
end
@inline function __strides_bit(
  sizes::Tuple{Integer,Vararg{Integer,N}},
  strides::Tuple{Nothing,Vararg{Any,N}}
) where {N}
  next = (first(sizes) + static(7)) & static(-8)
  (next, _strides(Base.tail(sizes), Base.tail(strides), next)...)
end
@inline function __strides_bit(
  sizes::Tuple{Integer,Vararg{Integer,N}},
  strides::Tuple{StrideReset{T},Vararg{Any,N}}
) where {N,T}
  next = (getfield(first(strides), :x) + static(7)) & static(-8)
  (next, _strides(Base.tail(sizes), Base.tail(strides), next)...)
end
@inline function _strides_bit(
  sizes::Tuple{Integer,Vararg{Integer,N}},
  strides::Tuple{Nothing,Vararg{Any,N}}
) where {N}
  (static(1), __strides_bit(Base.front(sizes), Base.tail(strides))...)
end

# 4th arg is bit
@inline function _strides_entry(
  sizes,
  strides,
  ::Val{R},
  ::Val{false}
) where {R}
  VR = Val{R}()
  sx = _strides_nobit(invpermtuple(sizes, VR), invpermtuple(strides, VR))
  permtuple(sx, VR)
end
@inline _strides_entry(::Tuple{}, ::Tuple{}, ::Val{()}, ::Val{true}) = ()
@inline function _strides_entry(
  ::Tuple{S},
  ::Tuple{Nothing},
  ::Val{R},
  ::Val{true}
) where {S,R}
  (static(1),)
end
@inline function _strides_entry(
  ::Tuple{S},
  strides::Tuple{Integer},
  ::Val{R},
  ::Val{true}
) where {S,R}
  strides
end
@inline function _strides_entry(
  ::Tuple{S},
  strides::Tuple{StrideReset{T}},
  ::Val{R},
  ::Val{true}
) where {S,T,R}
  (getfield(only(strides), :x),)
end
@inline function _strides_entry(sizes, strides, ::Val{R}, ::Val{true}) where {R}
  VR = Val{R}()
  sx = _strides_bit(invpermtuple(sizes, VR), invpermtuple(strides, VR))
  permtuple(sx, VR)
end

@inline _dense_dims(::Tuple{}) = ()
@inline _dense_dims(x::Tuple{Nothing,Vararg{Any}}) =
  (True(), _dense_dims(Base.tail(x))...)
@inline _dense_dims(x::Tuple{Integer,Vararg{Any}}) =
  (False(), _dense_dims(Base.tail(x))...)
# @inline _dense_dims(x::Tuple, ::Val{R}) where {R} = _dense_dims(invpermtuple(x, Val{R}()))

abstract type AbstractStrideArray{
  T,
  N,
  R,
  S<:Tuple{Vararg{Integer,N}},
  X<:Tuple{Vararg{Union{Integer,Nothing,StrideReset},N}},
  O<:Tuple{Vararg{Integer,N}}
} <: DenseArray{T,N} end
abstract type AbstractPtrStrideArray{T,N,R,S,X,O} <:
              AbstractStrideArray{T,N,R,S,X,O} end
const AbstractStrideVector{T,R,S,X,O} = AbstractStrideArray{T,1,R,S,X,O}
const AbstractStrideMatrix{T,R,S,X,O} = AbstractStrideArray{T,2,R,S,X,O}

struct AbstractPtrArray{T,N,R,S,X,O,P} <: AbstractPtrStrideArray{T,N,R,S,X,O}
  ptr::Ptr{P}
  sizes::S
  strides::X
  offsets::O
  # function AbstractPtrArray{T,N,R,S,X,O,P}(ptr, sizes, strides, offsets) where {
  #   T,N,R,S,X,O,P
  #   }
  #   @assert T !== Bit
  #   new{T,N,R,S,X,O,P}(ptr, sizes, strides, offsets)
  # end
end
const PtrArray{T,N,R,S,X,O} = AbstractPtrArray{T,N,R,S,X,O,T}
const PtrArray0{T,N,R,S,X} = AbstractPtrArray{T,N,R,S,X,NTuple{N,Zero},T}
const PtrArray1{T,N,R,S,X} = AbstractPtrArray{T,N,R,S,X,NTuple{N,One},T}

const BitPtrArray{N,R,S,X,O} = AbstractPtrArray{Bool,N,R,S,X,O,Bit}
const BitPtrArray0{N,R,S,X} = AbstractPtrArray{Bool,N,R,S,X,NTuple{N,Zero},Bit}
const BitPtrArray1{N,R,S,X} = AbstractPtrArray{Bool,N,R,S,X,NTuple{N,One},Bit}

const AbstractPtrVector{T,R,S,X,O,P} = AbstractPtrArray{T,1,R,S,X,O,P}
const AbstractPtrMatrix{T,R,S,X,O,P} = AbstractPtrArray{T,2,R,S,X,O,P}

const PtrVector{T,R,S,X,O} = AbstractPtrArray{T,1,R,S,X,O,T}
const PtrMatrix{T,R,S,X,O} = AbstractPtrArray{T,2,R,S,X,O,T}
const PtrVector0{T,R,S,X} = AbstractPtrArray{T,1,R,S,X,NTuple{1,Zero},T}
const PtrVector1{T,R,S,X} = AbstractPtrArray{T,1,R,S,X,NTuple{1,One},T}
const PtrMatrix0{T,R,S,X} = AbstractPtrArray{T,2,R,S,X,NTuple{2,Zero},T}
const PtrMatrix1{T,R,S,X} = AbstractPtrArray{T,2,R,S,X,NTuple{2,One},T}

const BitPtrVector{R,S,X,O} = AbstractPtrArray{Bool,1,R,S,X,O,Bit}
const BitPtrMatrix{R,S,X,O} = AbstractPtrArray{Bool,2,R,S,X,O,Bit}
const BitPtrVector0{R,S,X} = AbstractPtrArray{Bool,1,R,S,X,NTuple{1,Zero},Bit}
const BitPtrVector1{R,S,X} = AbstractPtrArray{Bool,1,R,S,X,NTuple{1,One},Bit}
const BitPtrMatrix0{R,S,X} = AbstractPtrArray{Bool,2,R,S,X,NTuple{2,Zero},Bit}
const BitPtrMatrix1{R,S,X} = AbstractPtrArray{Bool,2,R,S,X,NTuple{2,One},Bit}

struct SquarePtrMatrix{T,R,S,X,O} <:
       AbstractPtrStrideArray{T,2,R,Tuple{S,S},X,O}
  ptr::Ptr{T}
  size::S
  strides::X
  offsets::O
end
@inline SquarePtrMatrix(
  p::Ptr{T},
  s::S,
  strides::Tuple{X0,X1} = (nothing, nothing),
  offsets::Tuple{O0,O1} = (One(), One()),
  ::Val{R} = Val((1, 2))
) where {T,S,X0,X1,O0,O1,R} =
  SquarePtrMatrix{T,R,S,Tuple{X0,X1},Tuple{O0,O1}}(p, s, strides, offsets)
import LinearAlgebra
LinearAlgebra.checksquare(A::SquarePtrMatrix) = getfield(A, :size)

@inline valisbit(::AbstractPtrArray{<:Any,<:Any,<:Any,<:Any,<:Any,<:Any,Bit}) =
  Val(true)
@inline valisbit(
  ::AbstractPtrArray{<:Any,<:Any,<:Any,<:Any,<:Any,<:Any,<:Any}
) = Val(false)
@inline valisbit(::SquarePtrMatrix) = Val(false)

# function PtrArray(
#   ptr::Ptr{T}, sizes::S, strides::X, offsets::O, ::Val{R}
# ) where {T,N,R,S<:Tuple{Vararg{Integer,N}},X<:Tuple{Vararg{Any,N}},O<:Tuple{Vararg{Integer,N}}}
#   PtrArray{T,N,R,S,X,O}(ptr, sizes, strides, offsets)
# end

@inline function AbstractPtrArray(
  p::Ptr{T},
  sz::S,
  sx::X,
  so::O,
  ::Val{R}
) where {
  N,
  T,
  R,
  S<:Tuple{Vararg{Integer,N}},
  X<:Tuple{Vararg{Any,N}},
  O<:Tuple{Vararg{Integer,N}}
}
  AbstractPtrArray{T,N,R,S,X,O,T}(p, sz, sx, so)
end
@inline function AbstractPtrArray(
  p::Ptr{Bit},
  sz::S,
  sx::X,
  so::O,
  ::Val{R}
) where {
  N,
  R,
  S<:Tuple{Vararg{Integer,N}},
  X<:Tuple{Vararg{Any,N}},
  O<:Tuple{Vararg{Integer,N}}
}
  AbstractPtrArray{Bool,N,R,S,X,O,Bit}(p, sz, sx, so)
end

@inline function AbstractPtrArray(
  p::Ptr{T},
  sz::S,
  sx::X,
  so::O
) where {
  N,
  T,
  S<:Tuple{Vararg{Integer,N}},
  X<:Tuple{Vararg{Any,N}},
  O<:Tuple{Vararg{Integer,N}}
}
  AbstractPtrArray{T,N,ntuple(identity, Val(N)),S,X,O,T}(p, sz, sx, so)
end
@inline function AbstractPtrArray(
  p::Ptr{Bit},
  sz::S,
  sx::X,
  so::O
) where {
  N,
  S<:Tuple{Vararg{Integer,N}},
  X<:Tuple{Vararg{Any,N}},
  O<:Tuple{Vararg{Integer,N}}
}
  AbstractPtrArray{Bool,N,ntuple(identity, Val(N)),S,X,O,Bit}(p, sz, sx, so)
end

@inline function PtrArray(
  p::Ptr{T},
  sz::S,
  ::Val{R}
) where {T,N,S<:Tuple{Vararg{Integer,N}},R}
  sx = ntuple(Returns(nothing), Val(N))
  o = ntuple(Returns(static(1)), Val(N))
  AbstractPtrArray(p, sz, sx, o, Val(R))
end
@inline function PtrArray0(
  p::Ptr{T},
  sz::S,
  ::Val{R}
) where {T,N,S<:Tuple{Vararg{Integer,N}},R}
  sx = ntuple(Returns(nothing), Val(N))
  o = ntuple(Returns(static(0)), Val(N))
  AbstractPtrArray(p, sz, sx, o, Val(R))
end
@inline function PtrArray(
  p::Ptr{T},
  sz::S,
  sx::X,
  ::Val{R}
) where {T,N,S<:Tuple{Vararg{Integer,N}},X<:Tuple{Vararg{Any,N}},R}
  o = ntuple(Returns(static(1)), Val(N))
  AbstractPtrArray(p, sz, sx, o, Val(R))
end
@inline function PtrArray0(
  p::Ptr{T},
  sz::S,
  sx::X,
  ::Val{R}
) where {T,N,S<:Tuple{Vararg{Integer,N}},X<:Tuple{Vararg{Any,N}},R}
  o = ntuple(Returns(static(0)), Val(N))
  AbstractPtrArray(p, sz, sx, o, Val(R))
end
@inline function PtrArray(
  p::Ptr{T},
  sz::S
) where {T,N,S<:Tuple{Vararg{Integer,N}}}
  sx = ntuple(Returns(nothing), Val(N))
  o = ntuple(Returns(static(1)), Val(N))
  R = ntuple(identity, Val(N))
  AbstractPtrArray(p, sz, sx, o, Val(R))
end
@inline function PtrArray0(
  p::Ptr{T},
  sz::S
) where {T,N,S<:Tuple{Vararg{Integer,N}}}
  sx = ntuple(Returns(nothing), Val(N))
  o = ntuple(Returns(static(0)), Val(N))
  R = ntuple(identity, Val(N))
  AbstractPtrArray(p, sz, sx, o, Val(R))
end
@inline function PtrArray(
  p::Ptr{T},
  sz::S,
  sx::X
) where {T,N,S<:Tuple{Vararg{Integer,N}},X<:Tuple{Vararg{Any,N}}}
  o = ntuple(Returns(static(1)), Val(N))
  R = ntuple(identity, Val(N))
  AbstractPtrArray(p, sz, sx, o, Val(R))
end
@inline function PtrArray0(
  p::Ptr{T},
  sz::S,
  sx::X
) where {T,N,S<:Tuple{Vararg{Integer,N}},X<:Tuple{Vararg{Any,N}}}
  o = ntuple(Returns(static(0)), Val(N))
  R = ntuple(identity, Val(N))
  AbstractPtrArray(p, sz, sx, o, Val(R))
end

@generated function _nondense_strides(
  strides::Tuple{Vararg{Integer}},
  ::Val{F},
  ::Val{D}
) where {F,D}
  t = Expr(:tuple)
  for i in eachindex(D)
    if D[i]
      push!(t.args, nothing)
    else
      x = Expr(:call, getfield, :strides, i)
      if F
        x = Expr(:call, >>>, x, static(3))
      end
      push!(t.args, Expr(:call, StrideReset, x))
    end
  end
  Expr(:block, Expr(:meta, :inline), t)
end

@inline function LayoutPointers.stridedpointer(A::BitPtrArray)
  stridedpointer(getfield(A, :ptr), StrideIndex(A))
end

@inline function PtrArray(
  ptr::StridedPointer{T,N,<:Any,0,R,<:Any,O},
  sz::S,
  ::Val{D}
) where {T,N,R,O,D,S}
  sx = _nondense_strides(static_strides(ptr), Val(true), Val{D}())
  X = typeof(sx)
  PtrArray{T,N,R,S,X,O}(pointer(ptr), sz, sx, offsets(ptr))
end
@inline function PtrArray(
  ptr::StridedBitPointer{N,<:Any,0,R,<:Any,O},
  sz::S,
  ::Val{D}
) where {N,R,O,D,S}
  sx = _nondense_strides(static_strides(ptr), Val(false), Val{D}())
  X = typeof(sx)
  BitPtrArray{N,R,S,X,O}(pointer(ptr), sz, sx, offsets(ptr))
end
@inline PtrArray(A::BitArray{N}) where {N} = PtrArray(
  stridedpointer(A),
  static_size(A),
  Val(ntuple(Returns(true), Val(N)))
)

@inline _sparse_strides(::Tuple{}, ::Tuple{}) = ()
@inline function _sparse_strides(
  dd::Tuple{True,Vararg{Any,N}},
  sx::Tuple{Integer,Vararg{Integer,N}}
) where {N}
  (nothing, _sparse_strides(Base.tail(dd), Base.tail(sx))...)
end
@inline function _sparse_strides(
  dd::Tuple{False,Vararg{Any,N}},
  sx::Tuple{Integer,Vararg{Integer,N}}
) where {N}
  (StrideReset(first(sx)), _sparse_strides(Base.tail(dd), Base.tail(sx))...)
end

@inline function PtrArray(
  p::Ptr{T},
  sz::S,
  sx::X,
  offsets::O,
  ::Val{R}
) where {
  T,
  N,
  R,
  S<:Tuple{Vararg{Integer,N}},
  X<:Tuple{Vararg{Any,N}},
  O<:Tuple{Vararg{Integer,N}}
}
  AbstractPtrArray{T,N,R,S,X,O,T}(p, sz, sx, offsets)
end
@inline function PtrArray(
  p::Ptr{Bit},
  sz::S,
  sx::X,
  offsets::O,
  ::Val{R}
) where {
  N,
  R,
  S<:Tuple{Vararg{Integer,N}},
  X<:Tuple{Vararg{Any,N}},
  O<:Tuple{Vararg{Integer,N}}
}
  AbstractPtrArray{Bool,N,R,S,X,O,Bit}(p, sz, sx, offsets)
end

@generated _compact_rank(::Val{R}) where {R} = Val(map(r -> sum(<=(r), R), R))

@inline function PtrArray(A::AbstractArray{T,N}) where {T,N}
  p = LayoutPointers.memory_reference(A)[1]
  sz = static_size(A)
  sx = _sparse_strides(dense_dims(A), static_strides(A))
  R = map(Int, stride_rank(A))
  PtrArray(p, sz, sx, offsets(A), _compact_rank(Val(R)))
end

@inline Base.pointer(A::AbstractPtrStrideArray) = getfield(A, :ptr)

@inline Base.unsafe_convert(::Type{Ptr{T}}, A::AbstractStrideArray) where {T} =
  Base.unsafe_convert(Ptr{T}, pointer(A))
@inline Base.elsize(::Type{<:AbstractStrideArray{T}}) where {T} = sizeof(T)

@inline ArrayInterface.static_size(A::AbstractPtrStrideArray) =
  getfield(A, :sizes)
@inline function ArrayInterface.static_size(A::SquarePtrMatrix)
  s = getfield(A, :size)
  (s, s)
end
@inline function ArrayInterface.static_strides(
  A::AbstractPtrStrideArray{<:Any,<:Any,R}
) where {R}
  _strides_entry(static_size(A), getfield(A, :strides), Val{R}(), valisbit(A))
end
ArrayInterface.device(::AbstractStrideArray) = ArrayInterface.CPUPointer()
ArrayInterface.device(
  ::SubArray{T,NS,AbstractPtrArray{T,N,R,S,X,O,P}}
) where {T,NS,N,R,S,X,O,P} = ArrayInterface.CPUPointer()

@generated function ArrayInterface.contiguous_axis(
  ::Type{<:AbstractStrideArray{<:Any,<:Any,R,<:Any,X}}
) where {R,X}
  i = findfirst(isone, R)
  C = i === nothing ? -1 : (((X.parameters[i] === Nothing) || (X.parameters[i] === One)) ? i : -1)
  # C = i === nothing ? -1 : ((X.parameters[i] === Nothing) ? i : -1)
  StaticInt{C}()
end
ArrayInterface.contiguous_batch_size(::Type{<:AbstractStrideArray}) =
  StaticInt{0}()

ArrayInterface.known_size(
  ::Type{<:AbstractStrideArray{<:Any,<:Any,<:Any,S}}
) where {S} = Static.known(S)

@generated function ArrayInterface.stride_rank(
  ::Type{<:AbstractStrideArray{<:Any,<:Any,R}}
) where {R}
  t = Expr(:tuple)
  for r ∈ R
    push!(t.args, StaticInt{r}())
  end
  t
end
@generated function ArrayInterface.dense_dims(
  ::Type{<:AbstractStrideArray{<:Any,<:Any,<:Any,<:Any,X}}
) where {X}
  t = Expr(:tuple)
  for i in eachindex(X.parameters)
    if X.parameters[i] === Nothing
      push!(t.args, True())
    else
      push!(t.args, False())
    end
  end
  t
end

function onetupleexpr(N::Int)
  t = Expr(:tuple)
  for _ = 1:N
    push!(t.args, One())
  end
  Expr(:block, Expr(:meta, :inline), t)
end
@generated onetuple(::Val{N}) where {N} = onetupleexpr(N)

@inline function ptrarray0(
  p::Ptr{T},
  s::Tuple{Vararg{Union{Integer,StaticInt},N}},
  x::Tuple{Vararg{Union{Integer,StaticInt},N}},
  ::Val{D}
) where {T,N,D}
  PtrArray0(p, s, _nondense_strides(x, Val(false), Val{D}()))
end
@inline function PtrArray(
  p::Ptr{T},
  s::Tuple{Vararg{Union{Integer,StaticInt},N}},
  x::Tuple{Vararg{Union{Integer,StaticInt},N}},
  ::Val{D}
) where {T,N,D}
  PtrArray(p, s, _nondense_strides(x, Val(false), Val{D}()))
end

@inline sparse_strides(A::AbstractPtrStrideArray) = getfield(A, :strides)

@inline function LayoutPointers.zero_offsets(
  A::AbstractPtrStrideArray{<:Any,N,R}
) where {N,R}
  PtrArray(
    pointer(A),
    static_size(A),
    sparse_strides(A),
    ntuple(Returns(static(0)), Val(N)),
    Val{R}()
  )
end

intlog2(N::I) where {I<:Integer} = (8sizeof(I) - one(I) - leading_zeros(N)) % I
intlog2(::Type{T}) where {T} = intlog2(static_sizeof(T))
@generated intlog2(::StaticInt{N}) where {N} =
  Expr(:call, Expr(:curly, :StaticInt, intlog2(N)))

@inline Base.size(A::AbstractStrideArray) = map(Int, static_size(A))
@inline Base.strides(A::AbstractStrideArray) = map(Int, static_strides(A))
@inline function Base.stride(A::AbstractStrideArray, i::Int)
  x = Base.strides(A)
  @assert i > 0
  i <= length(x) ? @inbounds(x[i]) : last(x) * Int(last(static_size(A)))
end
@inline Base.stride(A::AbstractStrideArray, ::StaticInt{N}) where {N} =
  Base.stride(A, N)
@generated _oneto(x) = Expr(:new, Base.OneTo{Int}, :(x % Int))

@inline create_axis(s, ::Zero) = CloseOpen(s)
@inline create_axis(s, ::One) = _oneto(unsigned(s))
@inline create_axis(::StaticInt{N}, ::One) where {N} = One():StaticInt{N}()
@inline create_axis(s, o) = CloseOpen(o, s + o)

@inline ArrayInterface.static_axes(A::AbstractPtrArray) =
  map(create_axis, static_size(A), offsets(A))
@inline ArrayInterface.static_size(A::AbstractStrideArray) =
  static_size(PtrArray(A))
@inline ArrayInterface.static_axes(A::AbstractStrideArray) =
  static_axes(PtrArray(A))
@inline Base.axes(A::AbstractStrideArray) = static_axes(A)
@inline Base.axes(A::AbstractStrideArray, d::StaticInt) = static_axes(A, d)

@generated function ArrayInterface.axes_types(
  ::Type{<:AbstractStrideArray{T,N,R,S,X,O}}
) where {T,N,R,S,X,O}
  s = known(S)
  o = known(O)
  t = Expr(:curly, :Tuple)
  for i in eachindex(s, o)
    oi = o[i]
    si = s[i]
    if oi === nothing
      push!(t.args, CloseOpen{Int,Int})
    elseif oi == 0
      si = s[i]
      if si === nothing
        push!(t.args, CloseOpen{StaticInt{0},Int})
      else
        @assert si isa Int
        push!(t.args, CloseOpen{StaticInt{0},StaticInt{si}})
      end
    elseif oi == 1
      if si === nothing
        push!(t.args, Base.OneTo{Int})
      else
        @assert si isa Int
        push!(
          t.args,
          ArrayInterface.OptionallyStaticUnitRange{StaticInt{1},StaticInt{si}}
        )
      end
    else
      @assert oi isa Int
      if si === nothing
        push!(t.args, CloseOpen{StaticInt{oi},Int})
      else
        @assert si isa Int
        push!(t.args, CloseOpen{StaticInt{oi},StaticInt{oi + si}})
      end
    end
  end
  t
end

@inline ArrayInterface.offsets(A::AbstractPtrArray) = getfield(A, :offsets)
@inline ArrayInterface.static_length(A::AbstractStrideArray) =
  Static.reduce_tup(*, static_size(A))

# type stable, because index known at compile time
@inline type_stable_select(t::NTuple, ::StaticInt{N}) where {N} = getfield(t, N)
@inline type_stable_select(t::Tuple, ::StaticInt{N}) where {N} = getfield(t, N)
# type stable, because tuple is homogenous
@inline type_stable_select(t::NTuple, i::Integer) = getfield(t, i)
# make the tuple homogenous before indexing
@inline type_stable_select(t::Tuple, i::Integer) = getfield(map(Int, t), i)

@inline ArrayInterface._axes(A::AbstractStrideArray, i::Integer) = __axes(A, i)
@inline ArrayInterface._axes(A::AbstractStrideArray, i::Int) = __axes(A, i)
@inline ArrayInterface._axes(A::AbstractStrideArray, ::StaticInt{I}) where {I} =
  __axes(A, StaticInt{I}())

@inline function __axes(
  A::AbstractStrideArray{T,N},
  i::Union{Integer,StaticInt}
) where {T,N}
  if i ≤ N
    o = type_stable_select(offsets(A), i)
    s = type_stable_select(static_size(A), i)
    return create_axis(s, o)
  else
    return One():One()
  end
end
@inline Base.axes(A::AbstractStrideArray, i::Integer) = static_axes(A, i)

@inline function ArrayInterface.static_size(A::AbstractStrideVector, i::Int)
  d = Int(length(A))
  ifelse(isone(i), d, one(d))
end
@inline ArrayInterface.static_size(
  ::AbstractStrideVector,
  ::StaticInt{N}
) where {N} = One()
@inline ArrayInterface.static_size(A::AbstractStrideVector, ::StaticInt{1}) =
  length(A)
@inline ArrayInterface.static_size(
  A::AbstractStrideArray,
  ::StaticInt{N}
) where {N} = static_size(A)[N]
@inline ArrayInterface.static_size(A::AbstractStrideArray, i::Int) =
  type_stable_select(static_size(A), i)
@inline Base.size(A::AbstractStrideArray, i::Union{Integer,StaticInt})::Int =
  static_size(A, i)

# Base.IndexStyle(::Type{<:AbstractStrideArray}) = IndexCartesian()
# Base.IndexStyle(::Type{<:AbstractStrideVector{<:Any,<:Any,<:Any,1}}) = IndexLinear()
@generated function Base.IndexStyle(
  ::Type{A}
) where {T,N,R,S,X,A<:AbstractStrideArray{T,N,R,S,X}}
  # if is column major || is a transposed contiguous vector
  if X === NTuple{N,Nothing} && (
    (R === ntuple(identity, Val(N))) ||
    (R === (2, 1) && S <: Tuple{One,Integer})
  )
    :(IndexLinear())
  else
    :(IndexCartesian())
  end
end

@inline ManualMemory.preserve_buffer(::PtrArray) = nothing

@generated function pload(p::Ptr{T}) where {T}
  if Base.allocatedinline(T)
    Expr(:block, Expr(:meta, :inline), :(unsafe_load(p)))
  else
    Expr(
      :block,
      Expr(:meta, :inline),
      :(ccall(
        :jl_value_ptr,
        Ref{$T},
        (Ptr{Cvoid},),
        unsafe_load(Base.unsafe_convert(Ptr{Ptr{Cvoid}}, p))
      ))
    )
  end
end
@generated function pstore!(p::Ptr{T}, v::T) where {T}
  if Base.allocatedinline(T)
    Expr(:block, Expr(:meta, :inline), :(unsafe_store!(p, v); return nothing))
  else
    Expr(
      :block,
      Expr(:meta, :inline),
      :(
        unsafe_store!(
          Base.unsafe_convert(Ptr{Ptr{Cvoid}}, p),
          Base.pointer_from_objref(v)
        );
        return nothing
      )
    )
  end
end
@inline pstore!(p::Ptr{T}, v) where {T} = pstore!(p, convert(T, v))

rank2sortperm(R) =
  map(R) do r
    sum(map(≥(r), R))
  end

@generated function _offset_ptr(
  ptr::AbstractStridedPointer{T,N,C,B,R,X,O},
  i::Tuple{Vararg{Union{Integer,StaticInt,AbstractRange,Colon},NI}}
) where {T,N,C,B,R,NI,X,O}
  ptr_expr = :(pointer(ptr))
  N == 0 && return Expr(:block, Expr(:meta, :inline), ptr_expr)
  if N ≠ NI
    if (N > NI) & (NI ≠ 1)
      throw(
        ArgumentError(
          "If the dimension of the array exceeds the dimension of the index, then the index should be linear/one dimensional."
        )
      )
    end
    # use only the first index. Supports, for example `x[i,1,1,1,1]` when `x` is a vector, or `A[i]` where `A` is an array with dim > 1.
    _N = 1
  else
    _N = N
  end
  sp = rank2sortperm(R)
  q = Expr(
    :block,
    Expr(:meta, :inline),
    :(p = $ptr_expr),
    :(o = offsets(ptr)),
    :(x = static_strides(ptr))
  )
  for n ∈ 1:_N
    j = findfirst(==(n), sp)::Int
    ityp = i.parameters[j]
    ityp === Colon && continue
    index = Expr(:call, getfield, :i, j)
    if ityp <: AbstractRange
      index = :(first($index))
    end
    offst = Expr(:call, getfield, :o, j)
    strid = Expr(:call, getfield, :x, j)
    offexpr = (O.parameters[j] === Zero) ? index : :($index - $offst)
    offexpr = (X.parameters[j] === One) ? offexpr : :($offexpr * $strid)
    if T ≢ Bit
      push!(q.args, :(p += $offexpr))
    else
      push!(q.args, :(p += $offexpr >>> 3))
    end
  end
  push!(q.args, :(p))
  q
end

@inline function Base.getindex(
  A::BitPtrArray{N},
  i::Vararg{Union{Integer,StaticInt},N}
) where {N}
  C = Int(ArrayInterface.contiguous_axis(A))::Int
  fi = getfield(i, C) - getfield(offsets(A), C)
  u = pload(Ptr{UInt8}(_offset_ptr(stridedpointer(A), i)))
  (u >>> (fi & 7)) % Bool
end
@inline function Base.getindex(A::BitPtrArray, i::Union{Integer,StaticInt})
  j = i - oneunit(i)
  u = pload(Ptr{UInt8}(pointer(A)) + (j >>> 3))
  (u >>> (j & 7)) % Bool
end
@inline function Base.setindex!(
  A::BitPtrArray{N},
  v::Bool,
  i::Vararg{Union{Integer,StaticInt},N}
) where {N}
  C = Int(ArrayInterface.contiguous_axis(A))::Int
  fi = getfield(i, C) - getfield(offsets(A), C)
  p = Ptr{UInt8}(_offset_ptr(stridedpointer(A), i))
  u = pload(p)
  sh = fi & 7
  u &= ~(0x01 << sh)
  u |= v << sh
  pstore!(p, u)
  return v
end
@inline function Base.setindex!(
  A::BitPtrArray,
  v::Bool,
  i::Union{Integer,StaticInt}
)
  j = i - oneunit(i)
  p = Ptr{UInt8}(pointer(A)) + (j >>> 3)
  u = pload(p)
  sh = j & 7
  u &= ~(0x01 << sh) # 0 bit
  u |= v << sh
  pstore!(p, u)
  return v
end
# Base.@propagate_inbounds function Base.getindex(A::AbstractStrideArray, i::Vararg{Any,K}) where {K}
# end
Base.@propagate_inbounds Base.getindex(
  A::AbstractStrideVector,
  i::Integer,
  ::Colon
) = view(A, i, :)
Base.@propagate_inbounds Base.getindex(
  A::AbstractStrideVector,
  ::Colon,
  ::Integer
) = A

Base.@propagate_inbounds Base.getindex(
  A::AbstractStrideVector,
  i::Integer,
  ::Integer
) = getindex(A, i)
Base.@propagate_inbounds function Base.getindex(
  A::AbstractStrideArray,
  i::Vararg{Union{Integer,StaticInt},K}
) where {K}
  b = preserve_buffer(A)
  GC.@preserve b begin
    PtrArray(A)[i...]
  end
end
@inline unsafe_getindex(A::AbstractStrideVector, i::Integer, ::Integer) =
  unsafe_getindex(A, i)
@inline function unsafe_getindex(
  A::AbstractStrideArray,
  i::Vararg{Union{Integer,StaticInt},K}
) where {K}
  b = preserve_buffer(A)
  GC.@preserve b begin
    unsafe_getindex(PtrArray(A), i...)
  end
end
Base.@propagate_inbounds function Base.getindex(
  A::AbstractStrideArray,
  i::Vararg{Union{Integer,StaticInt,Colon,AbstractRange},K}
) where {K}
  view(A, i...)
end
Base.@propagate_inbounds function Base.setindex!(
  A::AbstractStrideArray,
  v,
  i::Vararg{Union{Integer,StaticInt},K}
) where {K}
  b = preserve_buffer(A)
  GC.@preserve b begin
    PtrArray(A)[i...] = v
  end
end
@inline function unsafe_setindex!(
  A::AbstractStrideArray,
  v,
  i::Vararg{Union{Integer,StaticInt},K}
) where {K}
  b = preserve_buffer(A)
  GC.@preserve b begin
    unsafe_setindex!(PtrArray(A), v, i...)
  end
end

@inline _offset_dense(::Tuple{}, ::Tuple{}) = Zero()
@inline _offset_dense(i::Tuple{I}, s::Tuple{S}) where {I,S} = i[1] * s[1]
@inline _offset_dense(
  i::Tuple{I,J,Vararg},
  s::Tuple{S,T,Vararg}
) where {I,J,S,T} = (i[1] + _offset_dense(Base.tail(i), Base.tail(s))) * s[1]
@inline function _offset_ptr_dense(
  p::Ptr{T},
  i::Tuple{Vararg{Integer}},
  s::Tuple{Vararg{Integer}}
) where {T}
  p + sizeof(T) * (first(i) + _offset_dense(Base.tail(i), Base.front(s)))
end
@inline function _offset_ptr_padded(
  p::Ptr{T},
  i::Tuple{Vararg{Integer}},
  x::Tuple{Vararg{Integer}}
) where {T}
  p + sizeof(T) * Static.reduce_tup(+, map(*, i, x))
end
@inline stride_rank_val(A::AbstractArray) = Val{map(Int, stride_rank(A))}()
@inline stride_rank_val(A::AbstractStrideArray{T,N,R}) where {T,N,R} = Val{R}()

@inline _offset_ptr(A::AbstractArray, i::Tuple{}) = pointer(A)
@inline function _offset_ptr(A::AbstractArray, i::Tuple{I}) where {I}
  pointer(A) + Base.elsize(A) * (i[1] - ArrayInterface.offset1(A))
end
@inline function _offset_ptr(A::AbstractArray, i::Tuple{I,J,Vararg}) where {I,J}
  A isa AbstractVector && return _offset_ptr(A, (first(i),))
  p = pointer(A)
  j = map(-, i, offsets(A))
  if all(Bool, dense_dims(A))
    R = stride_rank_val(A)
    _offset_ptr_dense(p, invpermtuple(j, R), invpermtuple(static_size(A), R))
  else
    _offset_ptr_padded(p, j, strides(A))
  end
end
@inline function unsafe_getindex(A::PtrArray, i::Vararg{Integer})
  pload(_offset_ptr(A, i))
end
@inline function unsafe_setindex!(
  A::PtrArray,
  v,
  i::Vararg{Integer,K}
) where {K}
  pstore!(_offset_ptr(A, i), v)
  v
end
@inline function unsafe_getindex(A::PtrArray{T}, i::Integer) where {T}
  pload(pointer(A) + (i - oneunit(i)) * static_sizeof(T))
end
@inline function unsafe_setindex!(A::PtrArray{T}, v, i::Integer) where {T}
  pstore!(pointer(A) + (i - oneunit(i)) * static_sizeof(T), v)
  v
end
@inline function unsafe_getindex(A::PtrVector{T}, i::Vararg{Integer}) where {T}
  i_ = first(i)
  pload(
    pointer(A) +
    (i_ - ArrayInterface.offset1(A)) * only(LayoutPointers.bytestrides(A))
  )
end
@inline function unsafe_setindex!(A::PtrVector{T}, v, i::Vararg{Integer}) where {T}
  i_ = first(i)
  pstore!(
    pointer(A) +
    (i_ - ArrayInterface.offset1(A)) * only(LayoutPointers.bytestrides(A)),
    v
  )
  v
end
@propagate_inbounds function Base.getindex(A::PtrArray, i::Vararg{Integer})
  @boundscheck checkbounds(A, i...)
  unsafe_getindex(A, i...)
end
@propagate_inbounds function Base.setindex!(
  A::PtrArray,
  v,
  i::Vararg{Integer,K}
) where {K}
  @boundscheck checkbounds(A, i...)
  unsafe_setindex!(A, v, i...)
end
@propagate_inbounds function Base.getindex(A::PtrArray{T}, i::Integer) where {T}
  @boundscheck checkbounds(A, i)
  unsafe_getindex(A, i)
end
@propagate_inbounds function Base.setindex!(
  A::PtrArray{T},
  v,
  i::Integer
) where {T}
  @boundscheck checkbounds(A, i)
  unsafe_setindex!(A, v, i)
end
@propagate_inbounds function Base.getindex(
  A::PtrVector{T},
  i::Integer
) where {T}
  @boundscheck checkbounds(A, i)
  unsafe_getindex(A, i)
end
@propagate_inbounds function Base.setindex!(
  A::PtrVector{T},
  v,
  i::Integer
) where {T}
  @boundscheck checkbounds(A, i)
  unsafe_setindex!(A, v, i)
end
# fallback implementations
@inline unsafe_getindex(A, I::Vararg{Any,K}) where {K} = @inbounds A[I...]
@inline unsafe_setindex!(A, v, I::Vararg{Any,K}) where {K} =
  @inbounds A[I...] = v

_scale(::False, x, _, __) = x
@inline function _scale(::True, x, num, denom)
  cmp = Static.gt(num, denom)
  numerator = IfElse.ifelse(cmp, num, denom)
  denominator = IfElse.ifelse(cmp, denom, num)
  frac = numerator ÷ denominator
  IfElse.ifelse(cmp, x * frac, x ÷ frac)
end

@inline function Base.reinterpret(
  ::Type{Tnew},
  A::PtrArray{Told,N}
) where {Tnew,Told,N}
  szt_old = static_sizeof(Told)
  szt_new = static_sizeof(Tnew)
  sz_old = static_size(A)
  sz1_new =
    _scale(first(contiguous_axis_indicator(A)), first(sz_old), szt_old, szt_new)
  sz_new = (sz1_new, Base.tail(sz_old)...)
  sp = reinterpret(Tnew, stridedpointer(A))
  PtrArray(sp, sz_new, val_dense_dims(A))
end

@generated function Base.reinterpret(
  ::typeof(reshape),
  ::Type{Tnew},
  A::PtrArray{Told,N,R,S,X,O}
) where {Told,Tnew,N,S,R,X,O}
  sz_old::Int = sizeof(Told)::Int
  sz_new::Int = sizeof(Tnew)::Int
  C = findfirst(==(1), R)::Int
  # sz_old < sz_new && push!(q.args, :(@assert size_A[$C] == $(sz_new ÷ sz_old)))
  if sz_old == sz_new
    size_expr = :s
    stride_expr = :x
    offs_expr = :o
    Rnew = R
  else
    size_expr = Expr(:tuple)
    stride_expr = Expr(:tuple)
    offs_expr = Expr(:tuple)
    Rnew = Expr(:tuple)
    if sz_old >= sz_new
      known_offsets = known(O)
      first_offset =
        if all(Base.Fix2(isa, Int), known_offsets) &&
           all(==(first(known_offsets)), known_offsets)
          first(known_offsets)
        else
          1
        end
      push!(offs_expr.args, static(first_offset))
      push!(Rnew.args, 1)
      push!(size_expr.args, :(StaticInt{$(sz_old ÷ sz_new)}()))
      push!(stride_expr.args, nothing)
    end
    for n ∈ 1:N
      sz_n = Expr(:call, getfield, :s, n)
      sx_n = Expr(:call, getfield, :x, n)
      of_n = Expr(:call, getfield, :o, n)
      if (sz_old != sz_new) && (X.parameters[n] ≢ Nothing)
        sx_n = Expr(:call, __scale, sx_n, static(sz_old), static(sz_new))
      end
      if n ≠ C
        push!(size_expr.args, sz_n)
        push!(stride_expr.args, sx_n)
        push!(offs_expr.args, of_n)
        r = R[n]
        r = if sz_old > sz_new
          r += 1#r > C
        elseif sz_old < sz_new
          r -= r > C
        end
        push!(Rnew.args, r)
      elseif sz_old > sz_new
        # add an axis
        push!(size_expr.args, sz_n)
        push!(stride_expr.args, sx_n)
        push!(offs_expr.args, of_n)
        push!(Rnew.args, 1 + R[n])
      end
    end
  end
  quote
    $(Expr(:meta, :inline))
    p = pointer(A)
    s = getfield(A, :sizes)
    x = getfield(A, :strides)
    o = getfield(A, :offsets)
    PtrArray(Ptr{$Tnew}(p), $size_expr, $stride_expr, $offs_expr, Val{$Rnew}())
  end
end

Base.LinearIndices(x::AbstractStrideVector) = static_axes(x, static(1))

@inline Base.vec(A::PtrArray{T,1}) where {T} = A
@inline function Base.vec(
  A::PtrArray{T,N,R,S,NTuple{N,Nothing}}
) where {T,N,R,S}
  PtrArray(pointer(A), (static_length(A),), (nothing,), (One(),), Val((1,)))
end
@inline Base.vec(A::StaticStrideArray{T,1}) where {T} = A
@inline Base.vec(A::StaticStrideArray{T,N}) where {T,N} =
  StrideArray(vec(PtrArray(A)), A)
@inline Base.vec(A::StrideArray) =
  StrideArray(vec(PtrArray(A)), preserve_buffer(A))

@inline function Base.reshape(
  A::PtrArray{T,N,R,S,NTuple{N,Nothing}},
  dims::Tuple{Vararg{Integer}}
) where {T,N,R,S}
  PtrArray(pointer(A), dims)
end

@inline function Base.reshape(
  A::PtrArray{T,N,R,S,NTuple{N,Nothing}},
  dims::Tuple{Vararg{Base.Integer}}
) where {T,N,R,S}
  PtrArray(pointer(A), dims)
end

@inline function Base.reshape(
  A::PtrArray{T,N,R,S,NTuple{N,Nothing}},
  dims::Tuple{Int,Vararg{Int}}
) where {T,N,R,S}
  PtrArray(pointer(A), dims)
end
@inline function Base.reshape(
  A::PtrArray{T,N,R,S,NTuple{N,Nothing}},
  dims::Tuple{Integer,Vararg{Integer}}
) where {T,N,R,S}
  PtrArray(pointer(A), dims)
end
@inline function Base.reshape(
  A::PtrArray{T,N,R,S,NTuple{N,Nothing}},
  dims::Tuple{Base.Integer,Vararg{Base.Integer}}
) where {T,N,R,S}
  PtrArray(pointer(A), dims)
end

@inline function Base.reshape(
  A::PtrArray{T,N,R,S,NTuple{N,Nothing}},
  dims::Tuple{Vararg{Int}}
) where {T,N,R,S}
  PtrArray(pointer(A), dims)
end

@inline function Base.reshape(
  A::PtrArray{T,N,R,S,NTuple{N,Nothing}},
  ::Tuple{}
) where {T,N,R,S}
  PtrArray(pointer(A), ())
end

@inline function Base.reshape(A::StrideArray, dims::Tuple{Int})
  StrideArray(PtrArray(pointer(A), dims), preserve_buffer(A))
end
@inline function Base.reshape(A::StrideArray, dims::Tuple{Vararg{Int}})
  StrideArray(PtrArray(pointer(A), dims), preserve_buffer(A))
end
@inline function Base.reshape(A::StrideArray, dims::Tuple{Int,Vararg{Int}})
  StrideArray(PtrArray(pointer(A), dims), preserve_buffer(A))
end
@inline function Base.reshape(A::StrideArray, dims::Tuple{Int,Int,Vararg{Int}})
  StrideArray(PtrArray(pointer(A), dims), preserve_buffer(A))
end
@inline function Base.reshape(A::StrideArray, dims::Tuple{Integer})
  StrideArray(PtrArray(pointer(A), dims), preserve_buffer(A))
end
@inline function Base.reshape(
  A::StrideArray,
  dims::Tuple{Integer,Integer,Vararg{Integer}}
)
  StrideArray(PtrArray(pointer(A), dims), preserve_buffer(A))
end
@inline function Base.reshape(A::StrideArray, dims::Tuple{Vararg{Base.Integer}})
  StrideArray(PtrArray(pointer(A), dims), preserve_buffer(A))
end
@inline function Base.reshape(
  A::StrideArray,
  dims::Tuple{Base.Integer,Vararg{Base.Integer}}
)
  StrideArray(PtrArray(pointer(A), dims), preserve_buffer(A))
end

@generated function Base.permutedims(
  A::AbstractPtrStrideArray{T,N,R,S,X,O},
  ::Val{P}
) where {P,T,N,R,S,X,O}
  length(P) == N ||
    throw("cannot perm $N-dimensional array with $P of length = $(length(P))")
  q = Expr(
    :block,
    Expr(:meta, :inline),
    :(sx = $getfield(A, :strides)),
    :(o = $getfield(A, :offsets))
  )
  squaretype = A <: SquarePtrMatrix
  if squaretype
    sz_expr = :($getfield(A, :size))
    PA = SquarePtrMatrix
  else
    push!(q.args, :(sz = $getfield(A, :sizes)))
    sz_expr = Expr(:tuple)
    PA = AbstractPtrArray
  end
  sx_expr = Expr(:tuple)
  o_expr = Expr(:tuple)
  rv_expr = Expr(:tuple)
  for n = 1:N
    j = P[n]
    squaretype || push!(sz_expr.args, :($getfield(sz, $j)))
    push!(sx_expr.args, :($getfield(sx, $j)))
    push!(o_expr.args, :($getfield(o, $j)))
    push!(rv_expr.args, R[j])
  end
  push!(
    q.args,
    :($PA(pointer(A), $sz_expr, $sx_expr, $o_expr, Val{$rv_expr}()))
  )
  q
end

@inline Base.adjoint(A::AbstractStrideMatrix{<:Real}) =
  permutedims(A, Val{(2, 1)}())
@inline Base.transpose(A::AbstractStrideMatrix) = permutedims(A, Val{(2, 1)}())

@inline function Base.transpose(a::AbstractPtrArray{<:Any,1})
  sx = getfield(getfield(a, :strides), 1)
  so = getfield(getfield(a, :offsets), 1)
  AbstractPtrArray(
    pointer(a),
    (One(), static_length(a)),
    (sx, sx),
    (so, so),
    Val{(2, 1)}()
  )
end
@inline Base.adjoint(a::AbstractPtrArray{<:Real}) = transpose(a)

@inline row_major(a::AbstractStrideVector) = a
@inline row_major(A::AbstractStrideMatrix) = transpose(A)
@inline row_major(A::AbstractStrideArray{T,N}) where {T,N} =
  permutedims(A, Val(ntuple(Base.Fix1(-, N + 1), Val(N))))

@inline undef_memory_buffer(::Type{T}, ::StaticInt{L}) where {T,L} =
  MemoryBuffer{L,T}(undef)
@inline undef_memory_buffer(::Type{T}, L) where {T} = Vector{T}(undef, L)
@inline undef_memory_buffer(::Type{Bit}, ::StaticInt{L}) where {L} =
  MemoryBuffer{(L + 7) >>> 3,UInt8}(undef)
@inline undef_memory_buffer(::Type{Bit}, L) =
  Vector{UInt8}(undef, (L + 7) >>> 3)
# @inline undef_memory_buffer(::Type{Bit}, L) = BitVector(undef, L)

struct AbstractStrideArrayImpl{T,N,R,S,X,O,P,A} <:
       AbstractStrideArray{T,N,R,S,X,O}
  ptr::AbstractPtrArray{T,N,R,S,X,O,P}
  data::A
end
const StrideArray{T,N,R,S,X,O,A} = AbstractStrideArrayImpl{T,N,R,S,X,O,T,A}
const StrideArray0{T,N,R,S,X,A} =
  AbstractStrideArrayImpl{T,N,R,S,X,NTuple{N,Zero},T,A}
const StrideArray1{T,N,R,S,X,A} =
  AbstractStrideArrayImpl{T,N,R,S,X,NTuple{N,One},T,A}
const BitStrideArray{N,R,S,X,O,A} =
  AbstractStrideArrayImpl{Bool,N,R,S,X,O,Bit,A}
const BitStrideArray0{N,R,S,X,A} =
  AbstractStrideArrayImpl{Bool,N,R,S,X,NTuple{N,Zero},Bit,A}
const BitStrideArray1{N,R,S,X,A} =
  AbstractStrideArrayImpl{Bool,N,R,S,X,NTuple{N,One},Bit,A}

const StrideVector{T,R,S,X,O,A} = StrideArray{T,1,R,S,X,O,A}
const StrideMatrix{T,R,S,X,O,A} = StrideArray{T,2,R,S,X,O,A}

@inline function StrideArray(
  B::AbstractPtrArray{T,N,R,S,X,O,P},
  data::A
) where {T,N,R,S,X,O,A,P}
  AbstractStrideArrayImpl{T,N,R,S,X,O,P,A}(B, data)
end
function StrideArray(::AbstractPtrArray, ::Integer)
  throw("StrideArray(::AbstractPtrArray, ::Integer) doesn't make any sense.")
end
function StrideArray(::AbstractPtrArray, ::Type{T}) where {T}
  throw("StrideArray(::AbstractPtrArray, ::Type{$T}) doesn't make any sense.")
end
function StrideArray(::AbstractPtrArray, ::Tuple{Vararg{Integer}})
  throw(
    "StrideArray(::AbstractPtrArray, ::Tuple{Vararg{Integer}}) doesn't make any sense."
  )
end

@inline Base.pointer(A::AbstractStrideArrayImpl) = pointer(getfield(A, :ptr))
@inline PtrArray(A::AbstractStrideArrayImpl) = getfield(A, :ptr)

@inline StrideArray(A::AbstractArray) = StrideArray(PtrArray(A), A)

@inline function StrideArray{T}(
  ::UndefInitializer,
  s::Tuple{Vararg{Union{Integer,StaticInt},N}}
) where {N,T}
  L = Static.reduce_tup(*, s)
  b = undef_memory_buffer(T, L)
  # For now, just trust Julia's alignment heuristics are doing the right thing
  # to save us from having to over-allocate
  # ptr = LayoutPointers.align(pointer(b))
  A = PtrArray(
    pointer(b),
    s,
    ntuple(Returns(nothing), Val(N)),
    ntuple(Returns(One()), Val(N)),
    Val(ntuple(identity, Val(N)))
  )
  StrideArray(A, b)
end
@inline function StrideArray(
  ptr::Ptr{T},
  s::S,
  x::X,
  b,
  ::Val{D}
) where {S,X,T,D}
  StrideArray(PtrArray(ptr, s, x, Val{D}()), b)
end
@inline StrideArray(f, s::Vararg{Union{Integer,StaticInt},N}) where {N} =
  StrideArray{Float64}(f, s)
@inline StrideArray(f, s::Tuple{Vararg{Union{Integer,StaticInt},N}}) where {N} =
  StrideArray{Float64}(f, s)
@inline StrideArray(
  f,
  ::Type{T},
  s::Vararg{Union{Integer,StaticInt},N}
) where {T,N} = StrideArray{T}(f, s)
@inline StrideArray{T}(f, s::Vararg{Union{Integer,StaticInt},N}) where {T,N} =
  StrideArray{T}(f, s)
@inline function StrideArray(
  A::PtrArray{T,N},
  s::Tuple{Vararg{Union{Integer,StaticInt},N}}
) where {T,N}
  PtrArray(stridedpointer(A), s, val_dense_dims(A))
end
@inline function StrideArray(
  A::AbstractArray{T,N},
  sz::Tuple{Vararg{Union{Integer,StaticInt},N}}
) where {T,N}
  # what is the point of this method? Why not `view(PtrArray(A), ...)`?
  p = pointer(A)
  sx = _sparse_strides(dense_dims(A), static_strides(A))
  R = map(Int, stride_rank(A))
  B = PtrArray(p, sz, sx, offsets(A), Val(R))
  StrideArray(B, preserve_buffer(A))
end
@inline function StrideArray{T}(
  f,
  s::Tuple{Vararg{Union{Integer,StaticInt},N}}
) where {T,N}
  A = StrideArray{T}(undef, s)
  @inbounds for i ∈ eachindex(A)
    A[i] = f(T)
  end
  A
end
@inline function StrideArray{T}(
  ::typeof(zero),
  s::Tuple{Vararg{Union{Integer,StaticInt},N}}
) where {T,N}
  ptr = Ptr{T}(Libc.calloc(prod(map(Int, s)), sizeof(T)))
  A = unsafe_wrap(Array{T}, ptr, s; own = true)
  StrideArray(A)
end
mutable struct StaticStrideArray{T,N,R,S,X,O,L} <:
               AbstractStrideArray{T,N,R,S,X,O}
  data::NTuple{L,T}
  @inline StaticStrideArray{T,N,R,S,X,O}(
    ::UndefInitializer
  ) where {T,N,R,S,X,O} =
    new{T,N,R,S,X,O,Int(ArrayInterface.reduce_tup(*, to_static_tuple(Val(S))))}()
  @inline StaticStrideArray{T,N,R,S,X,O,L}(
    ::UndefInitializer
  ) where {T,N,R,S,X,O,L} = new{T,N,R,S,X,O,L}()
end

@generated function to_static_tuple(::Val{S}) where {S}
  t = Expr(:tuple)
  for s ∈ S.parameters
    push!(t.args, Expr(:new, s))
  end
  t
end
@inline StrideArray(A::StaticStrideArray) = A

@inline ArrayInterface.static_size(
  ::StaticStrideArray{<:Any,<:Any,<:Any,S}
) where {S} = to_static_tuple(Val(S))
@inline function ArrayInterface.static_strides(
  A::StaticStrideArray{<:Any,N,R}
) where {N,R}
  _strides_entry(
    static_size(A),
    ntuple(Returns(nothing), Val{N}()),
    Val{R}(),
    Val(false)
  )
end
@inline ArrayInterface.offsets(
  ::StaticStrideArray{T,N,R,S,X,O}
) where {T,N,R,S,X,O} = to_static_tuple(Val(O))
@inline Base.unsafe_convert(::Type{Ptr{T}}, A::StaticStrideArray{T}) where {T} =
  Base.unsafe_convert(Ptr{T}, pointer_from_objref(A))
@inline Base.pointer(A::StaticStrideArray{T}) where {T} =
  Base.unsafe_convert(Ptr{T}, pointer_from_objref(A))

@inline StrideArray{T}(
  ::UndefInitializer,
  s::Tuple{Vararg{StaticInt,N}}
) where {N,T} = StaticStrideArray{T}(undef, s)
@inline StrideArray{T}(f, s::Tuple{Vararg{StaticInt,N}}) where {N,T} =
  StaticStrideArray{T}(f, s)
@inline StrideArray{T}(
  ::typeof(zero),
  s::Tuple{Vararg{StaticInt,N}}
) where {N,T} = StaticStrideArray{T}(zero, s) # Eager when static; assumed small

@inline function StaticStrideArray{T}(
  ::UndefInitializer,
  s::S
) where {N,T,S<:Tuple{Vararg{StaticInt,N}}}
  StaticStrideArray{
    T,
    N,
    ntuple(identity, Val(N)),
    S,
    NTuple{N,Nothing},
    NTuple{N,One}
  }(
    undef
  )
end

@inline function StaticStrideArray{T}(
  f,
  s::Tuple{Vararg{StaticInt,N}}
) where {T,N}
  A = StaticStrideArray{T}(undef, s)
  @inbounds for i ∈ eachindex(A)
    A[i] = f(T)
  end
  A
end

@inline LayoutPointers.preserve_buffer(A::MemoryBuffer) = A
@inline LayoutPointers.preserve_buffer(A::StrideArray) =
  preserve_buffer(getfield(A, :data))

@inline PtrArray(A::StrideArray) = getfield(A, :ptr)

@inline maybe_ptr_array(A) = A
@inline maybe_ptr_array(A::AbstractArray) =
  maybe_ptr_array(ArrayInterface.device(A), A)
@inline maybe_ptr_array(::ArrayInterface.CPUPointer, A::AbstractArray) =
  PtrArray(A)
@inline maybe_ptr_array(_, A::AbstractArray) = A

@inline ArrayInterface.static_size(A::AbstractStrideArrayImpl) =
  getfield(getfield(A, :ptr), :sizes)

@inline ArrayInterface.static_strides(A::AbstractStrideArrayImpl) =
  static_strides(getfield(A, :ptr))
@inline ArrayInterface.offsets(A::AbstractStrideArrayImpl) =
  offsets(getfield(A, :ptr))

@inline zeroindex(r::ArrayInterface.OptionallyStaticUnitRange{One}) =
  CloseOpen(Zero(), last(r))
@inline zeroindex(r::Base.OneTo) = CloseOpen(Zero(), last(r))
@inline zeroindex(r::AbstractUnitRange) = Zero():(last(r)-first(r))

@inline zeroindex(r::CloseOpen{Zero}) = r
@inline zeroindex(r::ArrayInterface.OptionallyStaticUnitRange{Zero}) = r

@inline LayoutPointers.zero_offsets(A::StrideArray) =
  StrideArray(LayoutPointers.zero_offsets(PtrArray(A)), preserve_buffer(A))
@inline LayoutPointers.zero_offsets(A::StaticStrideArray) =
  StrideArray(LayoutPointers.zero_offsets(PtrArray(A)), A)

@generated rank_to_sortperm_val(::Val{R}) where {R} =
  :(Val{$(rank_to_sortperm(R))}())
@inline function similar_layout(A::AbstractStrideArray{T,N,R}) where {T,N,R}
  permutedims(similar(permutedims(A, rank_to_sortperm_val(Val{R}()))), Val{R}())
end
@inline function similar_layout(A::AbstractArray)
  b = preserve_buffer(A)
  GC.@preserve b begin
    similar_layout(PtrArray(A))
  end
end
@inline function Base.similar(A::AbstractStrideArray{T}) where {T}
  StrideArray{T}(undef, static_size(A))
end
@inline Base.similar(A::BitPtrArray) = StrideArray{Bit}(undef, static_size(A))
@inline function Base.similar(A::AbstractStrideArray, ::Type{T}) where {T}
  StrideArray{T}(undef, static_size(A))
end

@inline function Base.view(
  A::AbstractStrideArray,
  i::Vararg{Union{Integer,AbstractRange,Colon},K}
) where {K}
  StrideArray(view(PtrArray(A), i...), preserve_buffer(A))
end
@inline function Base.view(
  A::AbstractStrideArray{<:Any,K},
  ::Vararg{Colon,K}
) where {K}
  A
end

@inline function zview(
  A::AbstractStrideArray,
  i::Vararg{Union{Integer,AbstractRange,Colon},K}
) where {K}
  StrideArray(zview(PtrArray(A), i...), preserve_buffer(A))
end
@inline function Base.permutedims(A::AbstractStrideArray, ::Val{P}) where {P}
  StrideArray(permutedims(PtrArray(A), Val{P}()), preserve_buffer(A))
end
@inline Base.adjoint(a::AbstractStrideVector{<:Real}) =
  StrideArray(transpose(PtrArray(a)), preserve_buffer(a))
@inline Base.transpose(a::AbstractStrideVector) =
  StrideArray(transpose(PtrArray(a)), preserve_buffer(a))

function gc_preserve_call(ex::Expr, skip::Int = 0, escape::Bool = true)
  q = Expr(:block)
  call = Expr(:call, escape ? esc(ex.args[1]) : ex.args[1])
  gcp = Expr(:gc_preserve, call)
  if length(ex.args) >= 2 && Meta.isexpr(ex.args[2], :parameters)
    params = ex.args[2]
    deleteat!(ex.args, 2)
    for i in eachindex(params.args)
      param = params.args[i]
      if Meta.isexpr(param, :kw, 2)
        push!(ex.args, param)
      else
        push!(ex.args, Expr(:kw, param, param))
      end
    end
  end
  for i ∈ 2:length(ex.args)
    arg = ex.args[i]
    if i + 1 ≤ skip
      push!(call.args, arg)
      continue
    end
    A = gensym(:A)
    buffer = gensym(:buffer)
    if arg isa Expr && arg.head === :kw
      push!(call.args, Expr(:kw, arg.args[1], Expr(:call, maybe_ptr_array, A)))
      arg = arg.args[2]
    else
      push!(call.args, Expr(:call, maybe_ptr_array, A))
    end
    if escape
      arg = esc(arg)
    end
    push!(q.args, :($A = $(arg)))
    push!(q.args, Expr(:(=), buffer, Expr(:call, preserve_buffer, A)))
    push!(gcp.args, buffer)
  end
  push!(q.args, gcp)
  q
end
"""
@gc_preserve foo(A, B, C)

Apply to a single, non-nested, function call. It will `GC.@preserve` all the arguments, and substitute suitable arrays with `PtrArray`s.
This has the benefit of potentially allowing statically sized mutable arrays to be both stack allocated, and passed through a non-inlined function boundary.
"""
macro gc_preserve(ex)
  @assert ex.head === :call
  gc_preserve_call(ex)
end

@inline LayoutPointers.zero_offsets(A::AbstractArray) =
  StrideArray(LayoutPointers.zero_offsets(PtrArray(A)), A)

@generated function Base.IndexStyle(
  ::Type{
    <:Union{
      <:BitPtrArray{N,R,S,NTuple{N,Nothing}},
      <:StrideArray{Bit,N,R,S,NTuple{N,Nothing}}
    }
  }
) where {N,R,S}
  # if is column major || is a transposed contiguous vector
  if (
    (R === ntuple(identity, Val(N))) ||
    (R === (2, 1) && S <: Tuple{One,Integer})
  )
    if N > 1
      ks1 = known(S)[1]
      if ks1 === nothing || ((ks1 & 7) != 0)
        return :(IndexCartesian())
      end
    end
    :(IndexLinear())
  else
    :(IndexCartesian())
  end
end

@inline Base.reinterpret(::Type{T}, A::AbstractStrideArrayImpl) where {T} =
  StrideArray(reinterpret(T, PtrArray(A)), preserve_buffer(A))
@inline Base.reinterpret(
  ::typeof(reshape),
  ::Type{T},
  A::AbstractStrideArrayImpl
) where {T} =
  StrideArray(reinterpret(reshape, T, PtrArray(A)), preserve_buffer(A))

@inline function Base.reinterpret(
  ::typeof(reshape),
  ::Type{U},
  B::AbstractStrideArrayImpl{T,N,R,S,X,O,P,A}
) where {U,T,N,R,S,X,O,P,A<:StaticStrideArray{U}}
  C = B.data
  if typeof(reinterpret(reshape, T, C)) === typeof(B)
    C
  else
    StrideArray(reinterpret(reshape, T, PtrArray(B)), preserve_buffer(B))
  end
end
@inline function Base.reinterpret(
  ::Type{U},
  B::AbstractStrideArrayImpl{T,N,R,S,X,O,P,A}
) where {U,T,N,R,S,X,O,P,A<:StaticStrideArray{U}}
  C = B.data
  if typeof(reinterpret(T, C)) === typeof(B)
    C
  else
    StrideArray(reinterpret(T, PtrArray(B)), preserve_buffer(B))
  end
end

@inline Base.reinterpret(::Type{T}, A::StaticStrideArray) where {T} =
  StrideArray(reinterpret(T, PtrArray(A)), A)
@inline Base.reinterpret(
  ::typeof(reshape),
  ::Type{T},
  A::StaticStrideArray
) where {T} = StrideArray(reinterpret(reshape, T, PtrArray(A)), A)

@inline function Base.view(
  A::AbstractPtrArray{T,N},
  i::Vararg{Union{Integer,AbstractRange,Colon},N}
) where {T,N}
  j = Base.to_indices(A, i)
  @boundscheck checkbounds(A, j...)
  PtrArray(SubArray(A, j))
end
@inline function Base.view(
  A::AbstractPtrArray{T,N},
  i::AbstractUnitRange
) where {T,N}
  V = vec(A)
  @boundscheck checkbounds(V, i)
  view(V, i)
end
@inline function Base.view(
  A::AbstractPtrArray{T,1},
  i::AbstractUnitRange
) where {T}
  @boundscheck checkbounds(A, i)
  sx = only(static_strides(A))
  if sx === static(1)
    p = pointer(A) + (first(i) - first(offsets(A))) * sizeof(T)
    PtrArray(p, (static_length(i),), (nothing,))
  else
    p = pointer(A) + (first(i) - first(offsets(A))) * sizeof(T) * sx
    PtrArray(p, (static_length(i),), (sx,))
  end
end

@inline function _view(
  B::BitPtrArray{N},
  i::Vararg{Union{Integer,AbstractRange,Colon},M}
) where {N,M}
  A = SubArray(B, Base.to_indices(B, i))
  p = _offset_ptr(stridedpointer(B), i)
  sz = static_size(A)
  sx = _sparse_strides(dense_dims(A), strides(A))
  R = map(Int, stride_rank(A))
  PtrArray(p, sz, sx, offsets(A), _compact_rank(Val(R)))
end
@inline function Base.view(
  B::BitPtrArray{N},
  i::Vararg{Union{Integer,AbstractRange,Colon},M}
) where {N,M}
  _view(B, i...)
end
@inline function Base.view(
  B::BitPtrArray{N},
  i::Vararg{Union{Integer,AbstractRange,Colon},N}
) where {N}
  _view(B, i...)
end

@inline function _bview_unitrange(A, i)
  sx = stride(A, static(1))
  @assert sx === static(1)
  off = (first(i) - first(offsets(A)))
  @assert off % 8 == 0
  p = pointer(A) + (off >>> 3)
  PtrArray(p, (static_length(i),), (sx,))
end
@inline function Base.view(A::BitPtrArray{N}, i::AbstractUnitRange) where {N}
  @assert static_size(A, static(1)) == static_strides(A, static(2))
  _bview_unitrange(A, i)
end
@inline function Base.view(A::BitPtrArray{1}, i::AbstractUnitRange)
  _bview_unitrange(A, i)
end
@inline Base.view(A::BitPtrArray{1}, ::Colon) = A
@inline Base.view(A::BitPtrArray{N}, ::Colon) where {N} = A

@inline function zview(
  A::AbstractPtrArray{T,N,R,S,X,O,P},
  i::Vararg{Union{Integer,AbstractRange,Colon},M}
) where {T,N,R,S,X,O,P,M}
  zero_offsets(view(A, i...))
end

@inline Base.view(A::AbstractPtrArray, ::Colon) = vec(A)
@inline zview(A::AbstractPtrArray, ::Colon) = vec(A)

@inline Base.view(A::AbstractPtrArray{<:Any,N}, ::Vararg{Colon,N}) where {N} = A
@inline zview(A::AbstractPtrArray{<:Any,N}, ::Vararg{Colon,N}) where {N} = A

@inline Base.view(A::AbstractPtrVector, ::Colon) = A
@inline zview(A::AbstractPtrVector, ::Colon) = A

"""
    rank_to_sortperm(::NTuple{N,Int}) -> NTuple{N,Int}

Returns the `sortperm` of the stride ranks.
"""
function rank_to_sortperm(R::NTuple{N,Int}) where {N}
  sp = ntuple(zero, Val{N}())
  r = ntuple(n -> sum(R[n] .≥ R), Val{N}())
  @inbounds for n = 1:N
    sp = Base.setindex(sp, n, r[n])
  end
  sp
end
rank_to_sortperm(R) = sortperm(R)
_one_to_nothing(x::I) where {I} = StrideReset(x)
_one_to_nothing(::One) = nothing
Base.@propagate_inbounds function square_view(A::PtrMatrix{T,R,S,X,O}, i::I) where {T,R,S,X,O,I}
  # sizes = size(A)
  # @boundscheck i <= min(sizes[1], sizes[2]) || throw(BoundsError(A, (i, i)))
  x = map(_one_to_nothing, static_strides(A))
  SquarePtrMatrix{T,R,I,typeof(x),O}(pointer(A), i, x, offsets(A))
end
# Base.@propagate_inbounds function square_view(A::AbstractMatrix, i)
#   StrideArray(square_view(PtrArray(A), i), preserve_buffer(A))
# end
Base.@propagate_inbounds function square_view(A::AbstractMatrix, i)
  @view(A[begin:begin-1+i, begin:begin-1+i])
end

module StrideArraysCore
if isdefined(Base, :Experimental) &&
   isdefined(Base.Experimental, Symbol("@max_methods"))
  @eval Base.Experimental.@max_methods 1
end

using LayoutPointers,
  StaticArrayInterface, ThreadingUtilities, ManualMemory, IfElse, Static
const ArrayInterface = StaticArrayInterface
using Static: StaticInt, StaticBool, True, False, Zero, One
const Integer = Union{StaticInt,Base.BitInteger}

using StaticArrayInterface:
  OptionallyStaticUnitRange,
  static_size,
  static_strides,
  offsets,
  indices,
  static_length,
  static_first,
  static_last,
  static_axes,
  dense_dims,
  stride_rank,
  StrideIndex,
  contiguous_axis_indicator
using LayoutPointers:
  AbstractStridedPointer,
  StridedPointer,
  StridedBitPointer,
  bytestrides,
  zstridedpointer,
  val_dense_dims,
  val_stride_rank,
  zero_offsets
using CloseOpenIntervals

using ManualMemory: preserve_buffer, offsetsize, MemoryBuffer

using SIMDTypes: NativeTypes, Bit

export PtrArray, StrideArray, StaticInt, static, @gc_preserve

@static if VERSION < v"1.7"
  struct Returns{T}
    x::T
  end
  (r::Returns)(args...) = r.x
end

@generated static_sizeof(::Type{T}) where {T} =
  :(StaticInt{$(Base.allocatedinline(T) ? sizeof(T) : sizeof(Int))}())
include("ptr_array.jl")
include("stridearray.jl")
include("thread_compatible.jl")
include("views.jl")
include("reshape.jl")
include("adjoints.jl")

if VERSION >= v"1.7.0" && hasfield(Method, :recursion_relation)
  dont_limit = Returns(true)
  for f in (_strides,)
    for m in methods(f)
      m.recursion_relation = dont_limit
    end
  end
end


end

using StrideArraysCore, ThreadingUtilities, Aqua
# using InteractiveUtils
using Test

@inline relu(x) = (y = zero(x); ifelse(x < y, y, x))

function closeopensum(x)
  s = zero(eltype(x))
  @inbounds @simd for i ∈ StrideArraysCore.CloseOpen(length(x))
    s += x[i+1]
  end
  s
end
function closeopensumfastmath(x)
  s = zero(eltype(x))
  @inbounds @fastmath for i ∈ StrideArraysCore.CloseOpen(length(x))
    s += x[i+1]
  end
  s
end
function cartesianindexsum(A)
  s = zero(eltype(A))
  @inbounds @simd for I ∈ CartesianIndices(A)
    s += A[I]
  end
  s
end
allocated_cartesianindexsum(x) = @allocated cartesianindexsum(x)
@noinline function conv!(f::F, _C, _A, _K, _b) where {F}
  C = StrideArraysCore.LayoutPointers.zero_offsets(_C)
  A = StrideArraysCore.LayoutPointers.zero_offsets(_A)
  K = StrideArraysCore.LayoutPointers.zero_offsets(_K)
  b = StrideArraysCore.LayoutPointers.zero_offsets(_b)

  for j₁ ∈ axes(C, 1), j₂ ∈ axes(C, 2), o ∈ axes(K, 4)
    s = zero(eltype(C))
    for k₁ ∈ axes(K, 1), k₂ ∈ axes(K, 2), i ∈ axes(K, 3)
      s += A[j₁+k₁, j₂+k₂, i] * K[k₁, k₂, i, o]
    end
    C[j₁, j₂, o] = f(s + b[o])
  end

  return C
end

function conv_group!(f::F, C, A, K, b, range) where {F}
  conv!(
    f,
    view(C, :, :, range),
    view(A, :, :, range),
    view(K, :, :, :, range),
    view(b, range),
  )
  return C
end
randn_stridearray(size...) = StrideArray(randn(Float32, size...), static.(size))

@noinline function conv_grouped!(f::F, C, A, K, b) where {F}
  conv_group!(f, C, A, K, b, static(1 + 0 * 4):static(1 * 4))
  conv_group!(f, C, A, K, b, static(1 + 1 * 4):static(2 * 4))
  conv_group!(f, C, A, K, b, static(1 + 2 * 4):static(3 * 4))
  conv_group!(f, C, A, K, b, static(1 + 3 * 4):static(4 * 4))
  conv_group!(f, C, A, K, b, static(1 + 4 * 4):static(5 * 4))
  conv_group!(f, C, A, K, b, static(1 + 5 * 4):static(6 * 4))
  conv_group!(f, C, A, K, b, static(1 + 6 * 4):static(7 * 4))
  conv_group!(f, C, A, K, b, static(1 + 7 * 4):static(8 * 4))
  return C
end

@inline function unpad(A::AbstractArray{<:Any,3})

  return view(A, static(2):static(9), static(2):static(9), :)
end

@testset "StrideArraysCore.jl" begin
  # Currently StrideArraysCore commits piracy with zero_offsets(A::AbstractArray) and preserve_buffer(A::MemoryBuffer)
  Aqua.test_all(StrideArraysCore; piracies = false)

  @testset "StrideArrays Basic" begin

    Acomplex = StrideArray{Complex{Float64}}(undef, (StaticInt(4), StaticInt(5)))
    @test @inferred(StrideArraysCore.ArrayInterface.known_size(Acomplex)) === (4, 5)
    Acomplex .= rand.(Complex{Float64})
    @test StrideArray(Acomplex) ===
          reinterpret(reshape, Complex{Float64}, reinterpret(reshape, Float64, Acomplex))
    @test StrideArray(Acomplex) ===
          reinterpret(Complex{Float64}, reinterpret(Float64, Acomplex))
    @test StrideArray(Acomplex) === reinterpret(
      reshape,
      Complex{Float64},
      reinterpret(reshape, Complex{UInt64}, Acomplex),
    )
    @test StrideArraysCore.static_size(Acomplex) ===
          StrideArraysCore.static_size(StrideArray(Acomplex)) ===
          (StaticInt(4), StaticInt(5))
    @test StrideArraysCore.static_size(reinterpret(reshape, Float64, Acomplex)) ===
          (StaticInt(2), StaticInt(4), StaticInt(5))
    A = rand(100, 100)
    B = copy(A)
    C = StrideArraysCore.PtrArray(A)
    @test typeof(@inferred(StrideArraysCore.axes(Acomplex))) ==
          @inferred(StrideArraysCore.ArrayInterface.axes_types(typeof(Acomplex)))
    @test typeof(@inferred(StrideArraysCore.axes(C))) ==
          @inferred(StrideArraysCore.ArrayInterface.axes_types(typeof(C)))
    @test typeof(
      @inferred(
        StrideArraysCore.axes(StrideArraysCore.LayoutPointers.zero_offsets(Acomplex))
      )
    ) == @inferred(
      StrideArraysCore.ArrayInterface.axes_types(
        typeof(StrideArraysCore.LayoutPointers.zero_offsets(Acomplex)),
      )
    )

    @test similar(C) isa StrideArraysCore.StrideArray
    @test view(C, :) === vec(C)
    let D = similar(C, Float32)
      @test D isa StrideArraysCore.StrideArray
      @test eltype(D) === Float32
    end
    GC.@preserve A begin
      #TODO: eliminate need to use `@inbounds` for simd
      # @test closeopensum(C) == closeopensum(A)
      # @code_llvm closeopensum(C)

      # @code_llvm closeopensum(A)
      @test closeopensumfastmath(C) == closeopensumfastmath(A)
      @test foldl(+, C) == foldl(+, A)
      # @test sum(C) == sum(A)
      @test closeopensum(C) ≈ closeopensumfastmath(C) ≈ sum(C)
      @test A == B
      C .*= 3
      @test A == 3 .* B
      @test C == A
      @test C == 3 .* B

      D = copy(A)
      Cslice = view(C, 23:48, 17:89)
      @test Base.stride(Cslice, 1) == 1
      Base.stride(C, 1) ==
      StrideArraysCore.static_strides(Cslice, 1) ==
      StrideArraysCore.static_strides(Cslice, static(1)) ==
      StrideArraysCore.static_strides(C, 1) ==
      StrideArraysCore.static_strides(C, static(1))
      @test Base.stride(Cslice, 2) ==
            Base.stride(C, 2) ==
            StrideArraysCore.static_strides(Cslice, 2) ==
            StrideArraysCore.static_strides(Cslice, static(2)) ==
            StrideArraysCore.static_strides(C, 2) ==
            StrideArraysCore.static_strides(C, static(2))
      if VERSION >= v"1.9.0-DEV.569"
        @test Base.stride(C, 3) ==
              StrideArraysCore.static_strides(C, 3) ==
              StrideArraysCore.static_strides(C, static(3))

      end
      @test Base.stride(C, 3) == StrideArraysCore.static_strides(C, 3)
      @test Base.stride(Cslice, 3) == StrideArraysCore.static_strides(Cslice, 3)
      @test Base.stride(Cslice, 3) == StrideArraysCore.static_strides(Cslice, static(3))
      @test Base.strides(Cslice) ==
            Base.strides(C) ==
            StrideArraysCore.static_strides(Cslice) ==
            StrideArraysCore.static_strides(C)

      Cslice .= 2
      @test D != C
      D[23:48, 17:89] .= 2
      @test D == C
      @test C === view(C, :, :)
      @test @inferred(size(view(C, StaticInt(1):StaticInt(8), :), 1)) === 8
      @test @inferred(
        StrideArraysCore.static_size(view(C, StaticInt(1):StaticInt(8), :), StaticInt(1))
      ) === StaticInt(8)
      @test @inferred(
        (static ∘ size)(view(C, StaticInt(1):StaticInt(8), :), StaticInt(1))
      ) === StaticInt(8)
      @test @inferred(
        StrideArraysCore.static_size(view(C, StaticInt(1):StaticInt(8), :), 1)
      ) === 8
      @test @inferred(
        StrideArraysCore.static_size(view(C, StaticInt(1):StaticInt(8), :), StaticInt(1))
      ) === StaticInt(8)
      @test @inferred(
        StrideArraysCore.ArrayInterface.known_size(
          typeof(view(C, StaticInt(1):StaticInt(8), :)),
        )
      ) === (8, nothing)

      @test C isa PtrArray
      @test C' isa PtrArray
      @test @inferred(permutedims(C, Val((2, 1)))) isa PtrArray
      @test @inferred(adjoint(C)) == D'
      @test @inferred(axes(C)) == axes(D)
      @test @inferred(axes(C')) == axes(D')
      @test @inferred(eachindex(view(C, :, 2:6))) == 1:(5*size(C, 1))
      @test @inferred(eachindex(view(C', 2:6, :)')) == 1:(5*size(C, 1))
      @test @inferred(eachindex(view(C, 2:6, :))) == CartesianIndices((5, size(C, 2)))
      @test @inferred(
        axes(StrideArraysCore.zview(C, StaticInt(2):StaticInt(6), :), StaticInt(1))
      ) === StrideArraysCore.CloseOpen(StaticInt(5))
      @test @inferred(
        axes(StrideArraysCore.zview(C, StaticInt(2):StaticInt(6), :), StaticInt(1))
      ) === StrideArraysCore.CloseOpen(StaticInt(5))
      @test @inferred(
        length(axes(StrideArraysCore.zview(C, StaticInt(2):StaticInt(6), :), StaticInt(1)))
      ) === 5
      if VERSION >= v"1.6"
        @test @inferred(
          StrideArraysCore.static_length(
            axes(StrideArraysCore.zview(C, StaticInt(2):StaticInt(6), :), StaticInt(1)),
          )
        ) === StaticInt(5)
      else
        @test @inferred(
          StrideArraysCore.static_length(
            axes(StrideArraysCore.zview(C, StaticInt(2):StaticInt(6), :), StaticInt(1)),
          )
        ) === 5
      end
      @test @inferred(
        StrideArraysCore.static_length(
          axes(StrideArraysCore.zview(C, StaticInt(2):StaticInt(6), :), StaticInt(1)),
        )
      ) === StaticInt(5)
      @test @inferred(
        (static ∘ length)(
          axes(StrideArraysCore.zview(C, StaticInt(2):StaticInt(6), :), StaticInt(1)),
        )
      ) === StaticInt(5)
      @test @inferred(
        length(axes(StrideArraysCore.zview(C, StaticInt(2):StaticInt(6), :), 1))
      ) === 5
      ax1, ax2 = axes(StrideArraysCore.zview(C, StaticInt(2):StaticInt(6), :))
      @test StrideArraysCore.ArrayInterface.known_length(ax1) == 5
      @test StrideArraysCore.ArrayInterface.known_length(ax2) ===
            StrideArraysCore.ArrayInterface.known_length(1:1)
      @test StrideArraysCore.ArrayInterface.known_first(ax1) == 0
      @test StrideArraysCore.ArrayInterface.known_first(ax2) == 0
      @test StrideArraysCore.ArrayInterface.known_step(ax1) == 1
      @test StrideArraysCore.ArrayInterface.known_step(ax2) == 1
      @test StrideArraysCore.ArrayInterface.known_last(ax1) == 4
      @test StrideArraysCore.ArrayInterface.known_last(ax2) ===
            StrideArraysCore.ArrayInterface.known_length(1:1)
    end
    W = rand(2, 3, 4)
    X = PtrArray(W)
    @test @inferred(StrideArraysCore.ArrayInterface.known_size(X)) ===
          (nothing, nothing, nothing)
    GC.@preserve W begin
      @test W == X
      @test permutedims(W, (1, 2, 3)) == @inferred(permutedims(X, Val((1, 2, 3))))
      @test permutedims(W, (1, 3, 2)) == @inferred(permutedims(X, Val((1, 3, 2))))
      @test permutedims(W, (2, 1, 3)) == @inferred(permutedims(X, Val((2, 1, 3))))
      @test permutedims(W, (2, 3, 1)) == @inferred(permutedims(X, Val((2, 3, 1))))
      @test permutedims(W, (3, 1, 2)) == @inferred(permutedims(X, Val((3, 1, 2))))
      @test permutedims(W, (3, 2, 1)) == @inferred(permutedims(X, Val((3, 2, 1))))
      if Base.JLOptions().check_bounds == 1
        @test_throws BoundsError X[length(X)+1]
        @test_throws BoundsError X[-4]
        @test_throws BoundsError X[2, 5, 3]
      end
      @test cartesianindexsum(W) ≈ cartesianindexsum(X)
      @test iszero(allocated_cartesianindexsum(X))
    end
    @test X === PtrArray(pointer(X), size(X))
    y = rand(77)
    GC.@preserve y begin
      z = PtrArray(y)
      @test y == z
      @test y' == z'
      @test PtrArray(y') === z'
      @test PtrArray(transpose(y)) === transpose(PtrArray(y))
      @test pointer(y) === pointer(z)
      if Base.JLOptions().check_bounds == 1
        @test_throws BoundsError z[-8]
        @test_throws BoundsError z[88]
      end
    end
  end
  @testset "ThreadingUtilities" begin
    xu = zeros(UInt, 100)
    x = rand(100)
    y = rand(100)
    z = rand(100)
    t = (x, y, z)
    pt, gt = StrideArraysCore.object_and_preserve(t)
    greet = ["Hello", "world", "hang", "in", "there"]
    pg, gg = StrideArraysCore.object_and_preserve(greet)
    ph, gh = StrideArraysCore.object_and_preserve(greet[1])
    pht, ght = StrideArraysCore.object_and_preserve((3, greet[1]))
    GC.@preserve xu gt gg gh ght begin
      ThreadingUtilities.store!(pointer(xu), pt, 0)
      @test @inferred(ThreadingUtilities.load(pointer(xu), typeof(pt), 0)) ==
            (6sizeof(UInt), t)
      offset = sizeof(UInt)
      for a ∈ t
        _p, g = StrideArraysCore.object_and_preserve(a)
        ThreadingUtilities.store!(pointer(xu), _p, offset)
        offset, p = @inferred(ThreadingUtilities.load(pointer(xu), typeof(_p), offset))
        @test g === a
        @test p isa PtrArray
        @test pointer(p) === pointer(a)
        @test p !== a
        @test p == a
      end
      new_offset = ThreadingUtilities.store!(pointer(xu), pg, offset)
      @test @inferred(ThreadingUtilities.load(pointer(xu), typeof(pg), offset)) ==
            (new_offset, greet)
      ThreadingUtilities.store!(pointer(xu), ph, offset)
      @test @inferred(ThreadingUtilities.load(pointer(xu), typeof(ph), offset)) ===
            (offset + sizeof(UInt), greet[1])
      ThreadingUtilities.store!(pointer(xu), pht, offset)
      @test @inferred(ThreadingUtilities.load(pointer(xu), typeof(pht), offset)) ===
            (offset + 2sizeof(UInt), (3, greet[1]))
    end

    greetsa = StrideArray(greet)
    @test greetsa == greet
    greetsa[1] = "howdy"
    greetsa[5] = "there!"
    @test greet[1] == "howdy"
    @test greet[5] == "there!"
    A = rand(ComplexF64, 4, 5)
    Asa = StrideArray(A)
    @test A == Asa
    Asa[3, 4] = 1234.5 + 678.9im
    @test A[3, 4] == 1234.5 + 678.9im
  end
  @testset "StrideArrays Initialization" begin
    A = StrideArray{Float64}(undef, (3, 5))
    @test StrideArraysCore.static_size(A) === (3, 5)
    @test StrideArraysCore.static_strides(A) === (StaticInt(1), 3)
    @test StrideArraysCore.static_length(A) === 15

    B = StrideArray(undef, (StaticInt(3), 5))
    @test StrideArraysCore.static_strides(B) === (StaticInt(1), StaticInt(3))
    @test StrideArraysCore.static_size(B) === (StaticInt(3), 5)
    @test StrideArraysCore.static_length(B) === 15

    D = StrideArray(undef, (StaticInt(3), StaticInt(5)))
    @test StrideArraysCore.static_strides(D) === (StaticInt(1), StaticInt(3))
    @test StrideArraysCore.static_size(D) === (StaticInt(3), StaticInt(5))
    @test StrideArraysCore.static_length(D) === StaticInt(15)
    @test D isa StrideArraysCore.StaticStrideArray
    for C ∈ Any[A, B, D]
      @test strides(C) === (1, 3)
      @test size(C) === (3, 5)
      @test StrideArraysCore.offsets(C) === (StaticInt(1), StaticInt(1))
      @test StrideArraysCore.offsets(StrideArraysCore.zero_offsets(C)) ===
            (StaticInt(0), StaticInt(0))
      C[2, 3] = 4
      StrideArraysCore.zero_offsets(C)[2, 3] = -10
      @test C[2, 3] === StrideArraysCore.zero_offsets(C)[1, 2] === 4.0
      @test C[3, 4] === StrideArraysCore.zero_offsets(C)[2, 3] === -10.0
    end
    @test all(iszero, StrideArray(zero, static(4), static(8)))
    @test all(iszero, StrideArray(zero, 1000, 2000))
    @test all(isone, StrideArray(one, static(4), static(8)))
    @test all(isone, StrideArray(one, 100, 200))
  end
  @testset "views" begin
    B0 = reshape(collect(1:12), 3, 4)
    B1 = StrideArray(B0)
    @test view(B0, :, 4:-1:1) == view(B1, :, 4:-1:1) == B1[:, 4:-1:1]
    @test view(B0, :, 1:2:4) == view(B1, :, 1:2:4) == B1[:, 1:2:4]
    @test view(B1, :, 4:-1:1) === B1[:, 4:-1:1]
    @test view(B1, 2, 1:2:4) === B1[2, 1:2:4]
    @test view(B0, 2, 4:-1:1) == view(B1, 2, 4:-1:1) == B1[2, 4:-1:1]
    @test view(B0, 2, 1:2:4) == view(B1, 2, 1:2:4) == B1[2, 1:2:4]
    @test view(B1, 2, 4:-1:1) === B1[2, 4:-1:1]
    @test view(B1, 2, 1:2:4) === B1[2, 1:2:4]
    A = StrideArray{Float64}(undef, (100, 100)) .= rand.()
    vA = view(A, 3:40, 2:50)
    @test vA === A[3:40, 2:50]
    vAslice = view(A, :, 2:50)
    vaslice = view(A, 2:50, 4)
    x = StrideArray{Float64}(undef, (100,)) .= rand.()
    vxslice = view(x, 2:50)
    @test vxslice === x[2:50]
    for (i, n) in enumerate(2:50)
      @test vaslice[i] == A[n, 4]
      @test vxslice[i] == x[n]
      for (j, m) in enumerate(3:40)
        @test A[m, n] == vA[j, i]
      end
      for j = 1:50
        @test A[j, n] == vAslice[j, i]
      end
    end
    a = StrideArray(zeros(77))
    b = a[10:20]
    c = @view(a[20:30])
    b[4] = 7
    @test a[13] == 7
    c[4] = 37
    @test a[23] == 37
    @test typeof(a) === typeof(b) === typeof(c)
  end
  @testset "BitPtrArray" begin
    b = collect(1:10) .> 5
    @test sprint((io, t) -> show(io, t), StrideArray(b)) == """
              Bool[0, 0, 0, 0, 0, 1, 1, 1, 1, 1]"""
    @test sprint((io, t) -> show(io, t), StrideArray(b)') == """
              Bool[0 0 0 0 0 1 1 1 1 1]"""
  end
  @testset "PtrArray0" begin
    x = collect(0:3)
    pzx = StrideArraysCore.PtrArray0(pointer(x), (4,))
    GC.@preserve x begin
      for i = 0:3
        @test pzx[i] == pzx[i, 1] == i
      end
    end
  end

  @testset "conv" begin


    A = randn_stridearray(10, 10, 32)
    C = randn_stridearray(10, 10, 32)
    K = randn_stridearray(3, 3, 4, 32)
    b = randn_stridearray(32)
    Ca = Array(C)
    @test Ca == C
    @test unpad(Ca) == unpad(C)
    conv_grouped!(relu, unpad(C), A, K, b)
    #Ca = Array(C);
    Aa = Array(A)
    Ka = Array(K)
    ba = Array(b)
    @test Aa == A
    @test Ka == K
    @test ba == b
    for i = 1:3
      @test axes(A, i) == axes(Aa, i)
      @test axes(K, i) == axes(Ka, i)
      @test axes(C, i) == axes(Ca, i)
    end
    @test axes(C, 4) == axes(Ca, 4)
    @test axes(b, 1) == axes(ba, 1)
    conv_grouped!(relu, unpad(Ca), Aa, Ka, ba)
    @test C ≈ Ca

  end
  @testset "square" begin
    A = rand(5, 5)
    GC.@preserve A begin
      B = StrideArraysCore.SquarePtrMatrix(pointer(A), 5)
      @test A == B
    end
  end

  @testset "PtrArray slicing" begin
    # Testing for the bug in https://github.com/JuliaSIMD/StrideArrays.jl/issues/88
    x = [1 3; 2 4]
    GC.@preserve x begin
      ptrarrays = (
        StrideArraysCore.PtrArray(pointer(x), (2, 2)),
        StrideArraysCore.PtrArray(pointer(x), (StaticInt(2), StaticInt(2))),
      )
      for y in ptrarrays
        # This triggered the bug, a 2D index into a Vector, which is used by display/show
        y1 = y[1, :]
        @test y1[2, 1] == x[1, 2]

        # Some general tests with slicing and bounds checking
        @test y[1, 1] == x[1, 1]
        @test y[2, 1] == x[2, 1]
        @test y[1, 2] == x[1, 2]
        @test y[2, 2] == x[2, 2]
        @test y1[1] == x[1, 1]
        @test y1[2] == x[1, 2]
        y2 = y[2, :]
        @test y2[1] == x[2, 1]
        @test y2[2] == x[2, 2]
        y3 = y[:, 1]
        @test y3[1] == x[1, 1]
        @test y3[2] == x[2, 1]
        @test_throws BoundsError y[1:5]
        @test_throws BoundsError y[3, :]
        @test_throws BoundsError y[:, 3]
        @test_throws BoundsError y[2:3, :]
        @test_throws BoundsError y1[3]
        @test_throws BoundsError y1[1:3]
        @test_throws BoundsError y2[3]
        @test_throws BoundsError y2[1:3]
      end
    end
  end
end

@generated function _object_and_preserve(x::T) where {T}
  # q = if sizeof(T) > 64
  # Expr(:block, :(rx = $(ManualMemory.Reference)(x)), :((rx, rx)))
  # elseif isbitstype(T)
  q = isbitstype(T) ? :((x, nothing)) : :((x, x))
  Expr(:block, Expr(:meta, :inline), q)
end
@inline object_and_preserve(x) = _object_and_preserve(x)

@inline object_and_preserve(x::String) = (x, x)
@inline object_and_preserve(A::AbstractArray{T}) where {T<:NativeTypes} =
  array_object_and_preserve(ArrayInterface.device(A), A)
@inline function object_and_preserve(A::AbstractArray{T}) where {T}
  if isbitstype(T) && ArrayInterface.device(A) === ArrayInterface.CPUPointer()
    (PtrArray(A), preserve_buffer(A))
  else
    (A, A)
  end
end
@inline function object_and_preserve(bc::Base.Broadcast.Broadcasted)
  if isbits(bc.f) && isbits(bc.axes)
    bca, bcp = object_and_preserve(bc.args)
    Base.Broadcast.Broadcasted(bc.f, bca, bc.axes), bcp
  else
    bc, bc
  end
end
@inline array_object_and_preserve(
  ::ArrayInterface.CPUPointer,
  A::AbstractArray
) = (PtrArray(A), preserve_buffer(A))
@inline array_object_and_preserve(_, A::AbstractArray) = _object_and_preserve(A)

@inline function object_and_preserve(t::Tuple{T}) where {T}
  o, p = object_and_preserve(only(t))
  (o,), (p,)
end
@inline function object_and_preserve(t::Tuple{T1,T2,Vararg}) where {T1,T2}
  oh, ph = object_and_preserve(first(t))
  ot, pt = object_and_preserve(Base.tail(t))
  (oh, ot...), (ph, pt...)
end
